/* Najliczniejsze skojarzenie w grafie dwudzielnym.
 * Zlozonosc: O(VE), ale w praktyce _bardzo_ szybkie. */

/* Wierzcholki 0..(n1-1) | n1..(n1+n2-1) */
#define MAXN 510

int n1,n2;
VI t[MAXN]; /* graf */

bool c[2*MAXN];
int skoj[2*MAXN]; /* Tablica skojarzen */

bool dfs(int v)
{
  c[v]=true;
  REP(i,t[v].size())
  {
    int x=t[v][i];
    if (skoj[x]==-1 || (!c[skoj[x]] && dfs(skoj[x])))
    {
      skoj[v]=x; skoj[x]=v;
      return true;
    }
  }
  return false;
}

void kojarz()
{
  REP(i,n1+n2) skoj[i]=-1;
  bool dasie=true;
  while (dasie)
  {
    dasie=false;
    REP(i,n1) c[i]=false;
    REP(i,n1) if (skoj[i]==-1 && !c[i]) dasie|=dfs(i);
  }
}

int main()
{
  kojarz();
  REP(i,n1) printf("%d %d\n",i,skoj[i]);
  return 0;
}
